//=============================================================================
// GoodTeleporter.
//=============================================================================
class GoodTeleporter expands Teleporter;

struct TelDescrType
{
	var int PathFlaggs;
	var byte OtherSideNum;
	var Teleporter MyOtherSide;
};
var TelDescrType Tel[16];
var byte NumTel;
var bool bURLTeleporterOnly,bHTTPURL;

function PostBeginPlay()
{
	Super.PostBeginPlay();
	bURLTeleporterOnly = ((InStr( URL, "/" ) >= 0) || (InStr( URL, "#" ) >= 0));
	if( bURLTeleporterOnly )
		bHTTPURL = (InStr(URL,"://")!=-1);
	else FindOtherSideTeleporter();
	if ( !bEnabled )
		DisableTeleporter();
}
function FindOtherSideTeleporter()
{
	local Teleporter Dest;
	local Actor S,E;
	local int Fl,Di;
	local byte i;
	
	foreach AllActors( class 'Teleporter', Dest )
		if( string(Dest.tag)~=URL && Dest!=Self )
		{
			Tel[NumTel].MyOtherSide = Dest;
			Tel[NumTel].OtherSideNum = 255;
			For( i=0; i<ArrayCount(Paths); i++ )
			{
				if( Paths[i]==-1 )
					Continue;
				describeSpec(Paths[i],S,E,Fl,Di);
				if( E==Dest )
				{
					Tel[NumTel].OtherSideNum = i;
					Tel[NumTel].PathFlaggs = Paths[i];
					Break;
				}
			}
			NumTel++;
			if( NumTel>=ArrayCount(Tel) )
				Return;
		}
}
function DisableTeleporter()
{
	local byte i;
	
	bEnabled = False;
	SetCollision(False);
	if( bURLTeleporterOnly )
		Return;
	// Disable AI paths from this.
	For( i=0; i<NumTel; i++ )
	{
		if( Tel[i].OtherSideNum==255 )
			Continue;
		Paths[Tel[i].OtherSideNum] = -1;
	}
}
function EnableTeleporter()
{
	local byte i;
	
	bEnabled = True;
	SetCollision(True);
	if( bURLTeleporterOnly )
		Return;
	// Enable AI paths on this.
	For( i=0; i<NumTel; i++ )
	{
		if( Tel[i].OtherSideNum==255 )
			Continue;
		Paths[Tel[i].OtherSideNum] = Tel[i].PathFlaggs;
	}
}
function Trigger( actor Other, pawn EventInstigator )
{
	local Actor A;
	
	if( bEnabled )
		DisableTeleporter();
	else EnableTeleporter();
	if ( bEnabled ) //teleport any pawns already in my radius
		ForEach TouchingActors(Class'Actor',A)
			Touch(A);
}
function Touch( actor Other )
{
	local Teleporter Dest;
	local Actor A;
	
	if ( !bEnabled )
		return;

	if( Other.bCanTeleport && Other.PreTeleport(Self)==false )
	{
		if( bURLTeleporterOnly )
		{
			// Teleport to a level on the net.
			if( PlayerPawn(Other) != None )
			{
				if( bHTTPURL )
					PlayerPawn(Other).ClientTravel(URL,TRAVEL_Absolute,False);
				else Level.Game.SendPlayer(PlayerPawn(Other), URL);
			}
		}
		else
		{
			// Teleport to a random teleporter in this local level, if more than one pick random.
			Dest = Tel[Rand(NumTel)].MyOtherSide;
			if( Dest != None )
			{
				// Teleport the actor into the other teleporter.
				if ( Other.IsA('Pawn') )
					PlayTeleportEffect( Pawn(Other), false);
				Dest.Accept( Other );
				if( (Event != '') && (Other.IsA('Pawn')) )
					foreach AllActors( class 'Actor', A, Event )
						A.Trigger( Other, Other.Instigator );
			}
			else Pawn(Other).ClientMessage( "Teleport destination not found!" );
		}
	}
}

defaultproperties
{
}
